<template>
	<div>
		<slot v-bind="{ runRecaptcha, recaptchaReset }" />
		<div v-if="hasRecaptchaDisclaimer" :class="$style.recaptchaText">
			This site is protected by reCAPTCHA and the Google
			<a href="https://policies.google.com/privacy" target="_blank">Privacy Policy</a> and
			<a href="https://policies.google.com/terms" target="_blank">Terms of Service</a> apply.
		</div>
		<div v-if="!recaptchaContainerId" ref="recaptchaContainer" />
	</div>
</template>

<script>
import { loadRecaptcha } from '@/utils/recaptcha';

export default {
	props: {
		hasRecaptchaDisclaimer: {
			type: Boolean,
			default: false,
		},

		recaptchaContainerId: {
			type: String,
			default: null,
		},

		waitToInitialize: {
			type: Boolean,
			default: false,
		},
	},

	async mounted() {
		await loadRecaptcha();

		if (!this.waitToInitialize) {
			this.initializeRecaptcha();
		}
	},

	async beforeDestroy() {
		await this.recaptchaReset();
	},

	methods: {
		initializeRecaptcha() {
			try {
				this.recaptchaId = window.grecaptcha.render(this.recaptchaContainerId || this.$refs.recaptchaContainer, {
					sitekey: this.$config.recaptcha.siteKey,
					size: 'invisible',
					badge: 'inline',
					callback: (response) => {
						// console.log('response', response);
						this.recaptchaExecuteResolve(response);
					},
					'expired-callback': (e) => {
						// console.log('recaptcha error expired', e);
						this.recaptchaExecuteReject();
					},
					'error-callback': (e) => {
						// console.log('recaptcha error', e);
						this.recaptchaExecuteReject();
					},
				});
			} catch (e) {
				console.error(e);
			}
		},

		async runRecaptcha() {
			await loadRecaptcha();

			if (this.waitToInitialize) {
				this.initializeRecaptcha();
			}

			return new Promise((resolve, reject) => {
				this.recaptchaExecuteResolve = resolve;
				this.recaptchaExecuteReject = reject;

				try {
					window.grecaptcha.execute(this.recaptchaId);
				} catch (e) {
					console.error(e);
				}
			});
		},

		async recaptchaReset() {
			if (!this.recaptchaId) return;

			await loadRecaptcha();

			try {
				window.grecaptcha.reset(this.recaptchaId);
			} catch (e) {
				console.error(e);
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.recaptchaText {
	@include use-text-style('type-300');

	margin-top: size('m');

	a {
		text-decoration: underline;
	}
}
</style>
